diff --git a/src/preprocessors/Stream5/snort_stream5_sctp.c b/src/preprocessors/Stream5/snort_stream5_sctp.c
new file mode 100644
index 0000000..70f76b3
--- /dev/null
+++ b/src/preprocessors/Stream5/snort_stream5_sctp.c
@@ -0,0 +1,792 @@
+/****************************************************************************
+ *
+ * Copyright (C) 2005-2013 Sourcefire, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License Version 2 as
+ * published by the Free Software Foundation.  You may not use, modify or
+ * distribute this program under any other version of the GNU General
+ * Public License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ ****************************************************************************/
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include "sf_types.h"
+#include "snort_debug.h"
+#include "detect.h"
+#include "plugbase.h"
+#include "mstring.h"
+#include "sfxhash.h"
+#include "util.h"
+#include "decode.h"
+
+#include "stream5_common.h"
+#include "stream_api.h"
+#include "snort_stream5_session.h"
+#include "stream_expect.h"
+#include "snort_stream5_sctp.h"
+
+#include "plugin_enum.h"
+#include "rules.h"
+#include "treenodes.h"
+#include "snort.h"
+#include "active.h"
+
+#include "portscan.h" /* To know when to create sessions for all SCTP */
+
+#include "dynamic-plugins/sp_dynamic.h"
+
+#include "profiler.h"
+#include "sfPolicy.h"
+
+#ifdef PERF_PROFILING
+PreprocStats s5SctpPerfStats;
+#endif
+
+/*  M A C R O S  **************************************************/
+/* actions */
+#define ACTION_NOTHING                  0x00000000
+
+/* sender/responder ip/port dereference */
+#define sctp_sender_ip lwSsn->client_ip
+#define sctp_sender_port lwSsn->client_port
+#define sctp_responder_ip lwSsn->server_ip
+#define sctp_responder_port lwSsn->server_port
+
+/*  D A T A  S T R U C T U R E S  ***********************************/
+typedef struct _SctpSession
+{
+    Stream5LWSession *lwSsn;
+
+    struct timeval ssn_time;
+
+    //uint8_t    c_ttl;
+    //uint8_t    s_ttl;
+
+} SctpSession;
+
+
+/*  G L O B A L S  **************************************************/
+Stream5SessionCache *sctp_lws_cache = NULL;
+static MemPool sctp_session_mempool;
+
+/*  P R O T O T Y P E S  ********************************************/
+static void Stream5ParseSctpArgs(Stream5SctpConfig *, char *, Stream5SctpPolicy *);
+static void Stream5PrintSctpConfig(Stream5SctpPolicy *);
+void SctpSessionCleanup(Stream5LWSession *lwssn);
+static int ProcessSctp(Stream5LWSession *, Packet *, Stream5SctpPolicy *, SFXHASH_NODE *);
+
+void Stream5InitSctp(Stream5GlobalConfig *gconfig)
+{
+    if (gconfig == NULL)
+        return;
+
+    /* Now SCTP */
+    if ((sctp_lws_cache == NULL) && (gconfig->track_sctp_sessions))
+    {
+        sctp_lws_cache = InitLWSessionCache(gconfig->max_sctp_sessions,
+                                           30, (3*60), 5, 0, &SctpSessionCleanup);
+
+        if(!sctp_lws_cache)
+        {
+            FatalError("Unable to init stream5 SCTP session cache, no SCTP "
+                       "stream inspection!\n");
+        }
+
+        if (mempool_init(&sctp_session_mempool,
+                    gconfig->max_sctp_sessions, sizeof(SctpSession)) != 0)
+        {
+            FatalError("%s(%d) Could not initialize sctp session memory pool.\n",
+                    __FILE__, __LINE__);
+        }
+    }
+}
+
+void Stream5SctpPolicyInit(Stream5SctpConfig *config, char *args)
+{
+    Stream5SctpPolicy *s5SctpPolicy;
+
+    if (config == NULL)
+        return;
+
+    s5SctpPolicy = (Stream5SctpPolicy *)SnortAlloc(sizeof(Stream5SctpPolicy));
+
+    Stream5ParseSctpArgs(config, args, s5SctpPolicy);
+
+    config->num_policies++;
+
+    /* Now add this context to the internal list */
+    if (config->policy_list == NULL)
+    {
+        config->policy_list =
+            (Stream5SctpPolicy **)SnortAlloc(sizeof(Stream5SctpPolicy *));
+    }
+    else
+    {
+        Stream5SctpPolicy **tmpPolicyList =
+            (Stream5SctpPolicy **)SnortAlloc(sizeof(Stream5SctpPolicy *) * config->num_policies);
+
+        memcpy(tmpPolicyList, config->policy_list,
+               sizeof(Stream5SctpPolicy *) * (config->num_policies - 1));
+
+        free(config->policy_list);
+
+        config->policy_list = tmpPolicyList;
+    }
+
+    config->policy_list[config->num_policies - 1] = s5SctpPolicy;
+
+    Stream5PrintSctpConfig(s5SctpPolicy);
+
+#ifdef REG_TEST
+    LogMessage("\n");
+    LogMessage("    SCTP Session Size: %lu\n",sizeof(SctpSession));
+    LogMessage("\n");
+#endif
+}
+
+static void Stream5ParseSctpArgs(Stream5SctpConfig *config, char *args, Stream5SctpPolicy *s5SctpPolicy)
+{
+    char **toks;
+    int num_toks;
+    int i;
+    char *index;
+    char **stoks = NULL;
+    int s_toks;
+    char *endPtr = NULL;
+
+    if (s5SctpPolicy == NULL)
+        return;
+
+    s5SctpPolicy->session_timeout = S5_DEFAULT_SSN_TIMEOUT;
+    s5SctpPolicy->flags = 0;
+
+    if(args != NULL && strlen(args) != 0)
+    {
+        toks = mSplit(args, ",", 6, &num_toks, 0);
+
+        i=0;
+
+        while(i < num_toks)
+        {
+            index = toks[i];
+
+            while(isspace((int)*index)) index++;
+
+            stoks = mSplit(index, " ", 3, &s_toks, 0);
+
+            if (s_toks == 0)
+            {
+                FatalError("%s(%d) => Missing parameter in Stream5 SCTP config.\n",
+                    file_name, file_line);
+            }
+
+            if(!strcasecmp(stoks[0], "timeout"))
+            {
+                if(stoks[1])
+                {
+                    s5SctpPolicy->session_timeout = strtoul(stoks[1], &endPtr, 10);
+                }
+
+                if (!stoks[1] || (endPtr == &stoks[1][0]))
+                {
+                    FatalError("%s(%d) => Invalid timeout in config file.  Integer parameter required.\n",
+                            file_name, file_line);
+                }
+
+                if ((s5SctpPolicy->session_timeout > S5_MAX_SSN_TIMEOUT) ||
+                    (s5SctpPolicy->session_timeout < S5_MIN_SSN_TIMEOUT))
+                {
+                    FatalError("%s(%d) => Invalid timeout in config file.  "
+                        "Must be between %d and %d\n",
+                        file_name, file_line,
+                        S5_MIN_SSN_TIMEOUT, S5_MAX_SSN_TIMEOUT);
+                }
+
+                if (s_toks > 2)
+                {
+                    FatalError("%s(%d) => Invalid Stream5 SCTP Policy option.  Missing comma?\n",
+                        file_name, file_line);
+                }
+            }
+            else if (!strcasecmp(stoks[0], "ignore_any_rules"))
+            {
+                s5SctpPolicy->flags |= STREAM5_CONFIG_IGNORE_ANY;
+
+                if (s_toks > 1)
+                {
+                    FatalError("%s(%d) => Invalid Stream5 SCTP Policy option.  Missing comma?\n",
+                        file_name, file_line);
+                }
+            }
+            else
+            {
+                FatalError("%s(%d) => Invalid Stream5 SCTP Policy option\n",
+                            file_name, file_line);
+            }
+
+            mSplitFree(&stoks, s_toks);
+            i++;
+        }
+
+        mSplitFree(&toks, num_toks);
+    }
+
+    if (s5SctpPolicy->bound_addrs == NULL)
+    {
+        if (config->default_policy != NULL)
+        {
+            FatalError("%s(%d) => Default Stream5 SCTP Policy already set. "
+                       "This policy must be bound to a specific host or "
+                       "network.\n", file_name, file_line);
+        }
+
+        config->default_policy = s5SctpPolicy;
+    }
+    else
+    {
+        if (s5SctpPolicy->flags & STREAM5_CONFIG_IGNORE_ANY)
+        {
+            FatalError("%s(%d) => \"ignore_any_rules\" option can be used only"
+                       " with Default Stream5 SCTP Policy\n", file_name, file_line);
+        }
+    }
+}
+
+static void Stream5PrintSctpConfig(Stream5SctpPolicy *s5SctpPolicy)
+{
+    LogMessage("Stream5 SCTP Policy config:\n");
+    LogMessage("    Timeout: %d seconds\n", s5SctpPolicy->session_timeout);
+    if (s5SctpPolicy->flags)
+    {
+        LogMessage("    Options:\n");
+        if (s5SctpPolicy->flags & STREAM5_CONFIG_IGNORE_ANY)
+        {
+            LogMessage("        Ignore Any -> Any Rules: YES\n");
+        }
+    }
+    //IpAddrSetPrint("    Bound Addresses:", s5SctpPolicy->bound_addrs);
+}
+
+
+int Stream5VerifySctpConfig(Stream5SctpConfig *config, tSfPolicyId policyId)
+{
+    if (config == NULL)
+        return -1;
+
+    if (!sctp_lws_cache)
+        return -1;
+
+    if (config->num_policies == 0)
+        return -1;
+
+    /* Post-process SCTP rules to establish SCTP ports to inspect. */
+    setPortFilterList(config->port_filter, IPPROTO_SCTP,
+            (config->default_policy->flags & STREAM5_CONFIG_IGNORE_ANY), policyId);
+
+    //printf ("SCTP Ports with Inspection/Monitoring\n");
+    //s5PrintPortFilter(config->port_filter);
+    return 0;
+}
+
+#ifdef DEBUG_STREAM5
+static void PrintSctpSession(SctpSession *us)
+{
+    LogMessage("SctpSession:\n");
+    LogMessage("    ssn_time:           %lu\n", us->ssn_time.tv_sec);
+    LogMessage("    sender IP:          0x%08X\n", us->sctp_sender_ip);
+    LogMessage("    responder IP:          0x%08X\n", us->sctp_responder_ip);
+    LogMessage("    sender port:        %d\n", us->sctp_sender_port);
+    LogMessage("    responder port:        %d\n", us->sctp_responder_port);
+    LogMessage("    flags:              0x%X\n", us->lwSsn->session_flags);
+}
+#endif
+
+Stream5LWSession *GetLWSctpSession(SessionKey *key)
+{
+    return GetLWSessionFromKey(sctp_lws_cache, key);
+}
+
+void SctpSessionCleanup(Stream5LWSession *lwssn)
+{
+    SctpSession *sctpssn = NULL;
+
+    if (lwssn->session_flags & SSNFLAG_PRUNED)
+    {
+        CloseStreamSession(&sfBase, SESSION_CLOSED_PRUNED);
+    }
+    else if (lwssn->session_flags & SSNFLAG_TIMEDOUT)
+    {
+        CloseStreamSession(&sfBase, SESSION_CLOSED_TIMEDOUT);
+    }
+    else
+    {
+        CloseStreamSession(&sfBase, SESSION_CLOSED_NORMALLY);
+    }
+
+    if (lwssn->proto_specific_data)
+        sctpssn = (SctpSession *)lwssn->proto_specific_data->data;
+
+    if (!sctpssn)
+    {
+        /* Huh? */
+        return;
+    }
+
+    /* Cleanup the proto specific data */
+    mempool_free(&sctp_session_mempool, lwssn->proto_specific_data);
+    lwssn->proto_specific_data = NULL;
+    lwssn->session_state = STREAM5_STATE_NONE;
+    lwssn->session_flags = SSNFLAG_NONE;
+    lwssn->expire_time = 0;
+    lwssn->ignore_direction = 0;
+
+    Stream5ResetFlowBits(lwssn);
+    FreeLWApplicationData(lwssn);
+
+    s5stats.sctp_sessions_released++;
+
+    RemoveSCTPSession(&sfBase);
+}
+
+uint32_t Stream5GetSctpPrunes(void)
+{
+    return sctp_lws_cache ? sctp_lws_cache->prunes : s5stats.sctp_prunes;
+}
+
+void Stream5ResetSctpPrunes(void)
+{
+    if ( sctp_lws_cache )
+        sctp_lws_cache->prunes = 0;
+}
+
+void Stream5ResetSctp(void)
+{
+    PurgeLWSessionCache(sctp_lws_cache);
+    mempool_clean(&sctp_session_mempool);
+}
+
+void Stream5CleanSctp(void)
+{
+    if ( sctp_lws_cache )
+        s5stats.sctp_prunes = sctp_lws_cache->prunes;
+
+    /* Clean up hash table -- delete all sessions */
+    DeleteLWSessionCache(sctp_lws_cache);
+    sctp_lws_cache = NULL;
+
+    mempool_destroy(&sctp_session_mempool);
+}
+
+static int NewSctpSession(Packet *p,
+                         Stream5LWSession *lwssn,
+                         Stream5SctpPolicy *s5SctpPolicy)
+{
+    SctpSession *tmp;
+    MemBucket *tmpBucket;
+    /******************************************************************
+     * create new sessions
+     *****************************************************************/
+    tmpBucket = mempool_alloc(&sctp_session_mempool);
+    if (tmpBucket == NULL)
+        return -1;
+
+    tmp = tmpBucket->data;
+    DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                "Creating new session tracker!\n"););
+
+    tmp->ssn_time.tv_sec = p->pkth->ts.tv_sec;
+    tmp->ssn_time.tv_usec = p->pkth->ts.tv_usec;
+    lwssn->session_flags |= SSNFLAG_SEEN_SENDER;
+
+    DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                "adding SctpSession to lightweight session\n"););
+    lwssn->proto_specific_data = tmpBucket;
+    lwssn->protocol = GET_IPH_PROTO(p);
+    lwssn->direction = FROM_SENDER;
+    tmp->lwSsn = lwssn;
+
+#ifdef DEBUG_STREAM5
+    PrintSctpSession(tmp);
+#endif
+    Stream5SetExpire(p, lwssn, s5SctpPolicy->session_timeout);
+
+    s5stats.sctp_sessions_created++;
+
+    AddSCTPSession(&sfBase);
+    if (perfmon_config && (perfmon_config->perf_flags & SFPERF_FLOWIP))
+        UpdateFlowIPState(&sfFlow, IP_ARG(lwssn->client_ip), IP_ARG(lwssn->server_ip), SFS_STATE_SCTP_CREATED);
+
+    return 0;
+}
+
+
+/*
+ * Main entry point for SCTP
+ */
+int Stream5ProcessSctp(Packet *p, Stream5LWSession *lwssn,
+                      Stream5SctpPolicy *s5SctpPolicy, SessionKey *skey)
+{
+    SFXHASH_NODE *hash_node = NULL;
+
+// XXX-IPv6 Stream5ProcessSCTP debugging
+
+    if (s5SctpPolicy == NULL)
+    {
+        int policyIndex;
+
+        /* Find an Sctp policy for this packet */
+        for (policyIndex = 0; policyIndex < s5_sctp_eval_config->num_policies; policyIndex++)
+        {
+            s5SctpPolicy = s5_sctp_eval_config->policy_list[policyIndex];
+
+            if (s5SctpPolicy->bound_addrs == NULL)
+                continue;
+
+            /*
+             * Does this policy handle packets to this IP address?
+             */
+            if(sfvar_ip_in(s5SctpPolicy->bound_addrs, GET_DST_IP(p)))
+            {
+                DEBUG_WRAP(DebugMessage(DEBUG_STREAM,
+                                        "[Stream5] Found sctp policy in IpAddrSet\n"););
+                break;
+            }
+        }
+
+        if (policyIndex == s5_sctp_eval_config->num_policies)
+            s5SctpPolicy = s5_sctp_eval_config->default_policy;
+
+        if (!s5SctpPolicy)
+        {
+            DEBUG_WRAP(DebugMessage(DEBUG_STREAM,
+                                    "[Stream5] Could not find Sctp Policy context "
+                                    "for IP %s\n", inet_ntoa(GET_DST_ADDR(p))););
+            return 0;
+        }
+    }
+
+      /* SCTP Sessions required */
+    if (lwssn == NULL)
+    {
+        if ((isPacketFilterDiscard(p, s5SctpPolicy->flags & STREAM5_CONFIG_IGNORE_ANY) == PORT_MONITOR_PACKET_DISCARD)
+                && !StreamExpectIsExpected(p, &hash_node))
+        {
+            //ignore the packet
+            UpdateFilteredPacketStats(&sfBase, IPPROTO_SCTP);
+            return 0;
+        }
+        /* Create a new session, mark SENDER seen */
+        lwssn = NewLWSession(sctp_lws_cache, p, skey, (void *)s5SctpPolicy);
+        s5stats.total_sctp_sessions++;
+    }
+    else
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+            "Stream5: Retrieved existing session object.\n"););
+    }
+
+    if (!lwssn)
+    {
+        LogMessage("Stream5: Failed to retrieve session object.  Out of memory?\n");
+        return -1;
+    }
+
+    p->ssnptr = lwssn;
+
+    /*
+     * Check if the session is expired.
+     * Should be done before we do something with the packet...
+     * ie, Insert a packet, or handle state change SYN, FIN, RST, etc.
+     */
+    if ((lwssn->session_state & STREAM5_STATE_TIMEDOUT) ||
+        Stream5Expire(p, lwssn))
+    {
+        lwssn->session_flags |= SSNFLAG_TIMEDOUT;
+
+        /* Session is timed out */
+        DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                    "Stream5 SCTP session timedout!\n"););
+
+        /* Clean it up */
+        SctpSessionCleanup(lwssn);
+
+        ProcessSctp(lwssn, p, s5SctpPolicy, hash_node);
+    }
+    else
+    {
+        ProcessSctp(lwssn, p, s5SctpPolicy, hash_node);
+        DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                    "Finished Stream5 SCTP cleanly!\n"
+                    "---------------------------------------------------\n"););
+    }
+    MarkupPacketFlags(p, lwssn);
+    Stream5SetExpire(p, lwssn, s5SctpPolicy->session_timeout);
+
+    return 0;
+}
+
+static int ProcessSctp(Stream5LWSession *lwssn, Packet *p,
+        Stream5SctpPolicy *s5SctpPolicy, SFXHASH_NODE *hash_node)
+{
+    char ignore;
+    SctpSession *sctpssn = NULL;
+
+    DEBUG_WRAP(
+            char *t = NULL;
+            char *l = NULL;
+            );
+
+    if (lwssn->proto_specific_data != NULL)
+        sctpssn = (SctpSession *)lwssn->proto_specific_data->data;
+
+    if (lwssn->protocol != IPPROTO_SCTP)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                    "Lightweight session not SCTP on SCTP packet\n"););
+        return ACTION_NOTHING;
+    }
+
+    if (lwssn->session_flags & (SSNFLAG_DROP_CLIENT|SSNFLAG_DROP_SERVER))
+    {
+        /* Got a packet on a session that was dropped (by a rule). */
+        GetLWPacketDirection(p, lwssn);
+
+        /* Drop this packet */
+        if (((p->packet_flags & PKT_FROM_SERVER) &&
+             (lwssn->session_flags & SSNFLAG_DROP_SERVER)) ||
+            ((p->packet_flags & PKT_FROM_CLIENT) &&
+             (lwssn->session_flags & SSNFLAG_DROP_CLIENT)))
+        {
+            DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                        "Blocking %s packet as session was blocked\n",
+                        p->packet_flags & PKT_FROM_SERVER ?
+                        "server" : "client"););
+            DisableDetect(p);
+            /* Still want to add this number of bytes to totals */
+            SetPreprocBit(p, PP_PERFMONITOR);
+            Active_DropPacket();
+#ifdef ACTIVE_RESPONSE
+            Stream5ActiveResponse(p, lwssn);
+#endif
+            return ACTION_NOTHING;
+        }
+    }
+
+    if (sctpssn == NULL)
+    {
+        lwssn->direction = FROM_SENDER;
+        IP_COPY_VALUE(lwssn->client_ip, GET_SRC_IP(p));
+        lwssn->client_port = p->sctph->sh_sport;
+        IP_COPY_VALUE(lwssn->server_ip, GET_DST_IP(p));
+        lwssn->server_port = p->sctph->sh_dport;
+        lwssn->session_state |= STREAM5_STATE_SENDER_SEEN;
+        if (NewSctpSession(p, lwssn, s5SctpPolicy) == -1)
+            return ACTION_NOTHING;
+        sctpssn = (SctpSession *)lwssn->proto_specific_data->data;
+
+        /* Check if the session is to be ignored */
+        if (hash_node)
+            ignore = SteamExpectProcessNode(p, lwssn, hash_node);
+        else
+            ignore = SteamExpectCheck(p, lwssn);
+        if (ignore)
+        {
+            /* Set the directions to ignore... */
+            lwssn->ignore_direction = ignore;
+            DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                        "Stream5: Ignoring packet from %d. "
+                        "Marking session marked as ignore.\n",
+                        p->packet_flags & PKT_FROM_CLIENT? "sender" : "responder"););
+            Stream5DisableInspection(lwssn, p);
+            return ACTION_NOTHING;
+        }
+    }
+
+    /* figure out direction of this packet */
+    GetLWPacketDirection(p, lwssn);
+
+    if (((p->packet_flags & PKT_FROM_SERVER) && (lwssn->ignore_direction & SSN_DIR_CLIENT)) ||
+        ((p->packet_flags & PKT_FROM_CLIENT) && (lwssn->ignore_direction & SSN_DIR_SERVER)))
+    {
+        Stream5DisableInspection(lwssn, p);
+        DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                    "Stream5 Ignoring packet from %d. "
+                    "Session marked as ignore\n",
+                    p->packet_flags & PKT_FROM_CLIENT? "sender" : "responder"););
+        return ACTION_NOTHING;
+    }
+
+    /* if both seen, mark established */
+    if(p->packet_flags & PKT_FROM_SERVER)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                    "Stream5: Updating on packet from responder\n"););
+        lwssn->session_flags |= SSNFLAG_SEEN_RESPONDER;
+#ifdef ACTIVE_RESPONSE
+        SetTTL(lwssn, p, 0);
+#endif
+
+        DEBUG_WRAP(
+                t = "Responder";
+                l = "Sender");
+    }
+    else
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
+                    "Stream5: Updating on packet from client\n"););
+        /* if we got here we had to see the SYN already... */
+        lwssn->session_flags |= SSNFLAG_SEEN_SENDER;
+#ifdef ACTIVE_RESPONSE
+        SetTTL(lwssn, p, 1);
+#endif
+
+        DEBUG_WRAP(
+                t = "Sender";
+                l = "Responder");
+    }
+
+    if (!(lwssn->session_flags & SSNFLAG_ESTABLISHED))
+    {
+        if ((lwssn->session_flags & SSNFLAG_SEEN_SENDER) &&
+            (lwssn->session_flags & SSNFLAG_SEEN_RESPONDER))
+        {
+            lwssn->session_flags |= SSNFLAG_ESTABLISHED;
+        }
+    }
+
+    return ACTION_NOTHING;
+}
+
+void SctpUpdateDirection(Stream5LWSession *ssn, char dir,
+                        snort_ip_p ip, uint16_t port)
+{
+    SctpSession *sctpssn = (SctpSession *)ssn->proto_specific_data->data;
+    snort_ip tmpIp;
+    uint16_t tmpPort;
+
+    if (IP_EQUALITY(&sctpssn->sctp_sender_ip, ip) && (sctpssn->sctp_sender_port == port))
+    {
+        if ((dir == SSN_DIR_SENDER) && (ssn->direction == SSN_DIR_SENDER))
+        {
+            /* Direction already set as SENDER */
+            return;
+        }
+    }
+    else if (IP_EQUALITY(&sctpssn->sctp_responder_ip, ip) && (sctpssn->sctp_responder_port == port))
+    {
+        if ((dir == SSN_DIR_RESPONDER) && (ssn->direction == SSN_DIR_RESPONDER))
+        {
+            /* Direction already set as RESPONDER */
+            return;
+        }
+    }
+
+    /* Swap them -- leave ssn->direction the same */
+    tmpIp = sctpssn->sctp_sender_ip;
+    tmpPort = sctpssn->sctp_sender_port;
+    sctpssn->sctp_sender_ip = sctpssn->sctp_responder_ip;
+    sctpssn->sctp_sender_port = sctpssn->sctp_responder_port;
+    sctpssn->sctp_responder_ip = tmpIp;
+    sctpssn->sctp_responder_port = tmpPort;
+}
+
+void s5SctpSetPortFilterStatus(unsigned short port, uint16_t status, tSfPolicyId policyId, int parsing)
+{
+    Stream5Config *config;
+    Stream5SctpConfig *sctp_config;
+
+#ifdef SNORT_RELOAD
+    if (parsing && (s5_swap_config != NULL))
+        config = (Stream5Config *)sfPolicyUserDataGet(s5_swap_config, policyId);
+    else
+#endif
+    config = (Stream5Config *)sfPolicyUserDataGet(s5_config, policyId);
+
+    if (config == NULL)
+        return;
+
+    sctp_config = config->sctp_config;
+    if (sctp_config == NULL)
+        return;
+
+    sctp_config->port_filter[port] |= status;
+}
+
+void s5SctpUnsetPortFilterStatus(unsigned short port, uint16_t status, tSfPolicyId policyId, int parsing)
+{
+    Stream5Config *config;
+    Stream5SctpConfig *sctp_config;
+
+#ifdef SNORT_RELOAD
+    if (parsing && (s5_swap_config != NULL))
+        config = (Stream5Config *)sfPolicyUserDataGet(s5_swap_config, policyId);
+    else
+#endif
+    config = (Stream5Config *)sfPolicyUserDataGet(s5_config, policyId);
+
+    if (config == NULL)
+        return;
+
+    sctp_config = config->sctp_config;
+    if (sctp_config == NULL)
+        return;
+
+    sctp_config->port_filter[port] &= ~status;
+}
+
+int s5SctpGetPortFilterStatus(unsigned short port, tSfPolicyId policyId, int parsing)
+{
+    Stream5Config *config;
+    Stream5SctpConfig *sctp_config;
+
+#ifdef SNORT_RELOAD
+    if (parsing && (s5_swap_config != NULL))
+        config = (Stream5Config *)sfPolicyUserDataGet(s5_swap_config, policyId);
+    else
+#endif
+    config = (Stream5Config *)sfPolicyUserDataGet(s5_config, policyId);
+
+    if (config == NULL)
+        return PORT_MONITOR_NONE;
+
+    sctp_config = config->sctp_config;
+    if (sctp_config == NULL)
+        return PORT_MONITOR_NONE;
+
+    return (int)sctp_config->port_filter[port];
+}
+
+void Stream5SctpConfigFree(Stream5SctpConfig *config)
+{
+    int i;
+
+    if (config == NULL)
+        return;
+
+    /* Cleanup SCTP Policies and the list */
+    for (i = 0; i < config->num_policies; i++)
+    {
+        Stream5SctpPolicy *policy = config->policy_list[i];
+
+        if (policy->bound_addrs != NULL)
+            sfvar_free(policy->bound_addrs);
+        free(policy);
+    }
+
+    free(config->policy_list);
+    free(config);
+}
+
